Index: trunk/src/VBox/Debugger/DBGCCmdHlp.cpp
===================================================================
--- trunk/src/VBox/Debugger/DBGCCmdHlp.cpp	(revision 41546)
+++ trunk/src/VBox/Debugger/DBGCCmdHlp.cpp	(revision 41553)
@@ -383,5 +383,5 @@
 
             default:
-                rc = VERR_PARSE_INCORRECT_ARG_TYPE;
+                rc = VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
         }
 
@@ -697,5 +697,5 @@
         case DBGCVAR_TYPE_HC_PHYS:
         default:
-            return VERR_PARSE_CONVERSION_FAILED;
+            return VERR_DBGC_PARSE_CONVERSION_FAILED;
     }
 }
@@ -768,7 +768,7 @@
         case DBGCVAR_TYPE_SYMBOL:
         case DBGCVAR_TYPE_STRING:
-            return VERR_PARSE_INCORRECT_ARG_TYPE; /** @todo better error code! */
+            return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE; /** @todo better error code! */
         default:
-            return VERR_PARSE_INCORRECT_ARG_TYPE;
+            return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
     }
     *pu64Number = u64Number;
@@ -816,5 +816,5 @@
                 return VINF_SUCCESS;
             }
-            return VERR_PARSE_INCORRECT_ARG_TYPE; /** @todo better error code! */
+            return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE; /** @todo better error code! */
 
         case DBGCVAR_TYPE_GC_FLAT:
@@ -829,5 +829,5 @@
         case DBGCVAR_TYPE_SYMBOL:
         default:
-            return VERR_PARSE_INCORRECT_ARG_TYPE;
+            return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
     }
 }
@@ -882,5 +882,5 @@
 
                 case DBGCVAR_TYPE_GC_FAR:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_PHYS:
@@ -891,5 +891,5 @@
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_FLAT:
@@ -901,5 +901,5 @@
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_PHYS:
@@ -910,5 +910,5 @@
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_NUMBER:
@@ -919,5 +919,5 @@
                 case DBGCVAR_TYPE_STRING:
                 case DBGCVAR_TYPE_SYMBOL:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_UNKNOWN:
@@ -938,5 +938,5 @@
                         return VINF_SUCCESS;
                     }
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_GC_FAR:
@@ -952,5 +952,5 @@
                             return VINF_SUCCESS;
                     }
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_FLAT:
@@ -964,5 +964,5 @@
                             return VINF_SUCCESS;
                     }
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_PHYS:
@@ -975,5 +975,5 @@
                             return VINF_SUCCESS;
                     }
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_NUMBER:
@@ -984,5 +984,5 @@
                 case DBGCVAR_TYPE_STRING:
                 case DBGCVAR_TYPE_SYMBOL:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_UNKNOWN:
@@ -997,8 +997,8 @@
                 case DBGCVAR_TYPE_GC_FLAT:
                     //rc = MMR3PhysGCPhys2GCVirtEx(pDbgc->pVM, pResult->u.GCPhys, ..., &pResult->u.GCFlat); - yea, sure.
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_FAR:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_PHYS:
@@ -1013,5 +1013,5 @@
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_PHYS:
@@ -1022,5 +1022,5 @@
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_NUMBER:
@@ -1031,5 +1031,5 @@
                 case DBGCVAR_TYPE_STRING:
                 case DBGCVAR_TYPE_SYMBOL:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_UNKNOWN:
@@ -1043,8 +1043,8 @@
             {
                 case DBGCVAR_TYPE_GC_FLAT:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_FAR:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_PHYS:
@@ -1054,5 +1054,5 @@
                         return VINF_SUCCESS;
                     /** @todo more memory types! */
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_FLAT:
@@ -1065,5 +1065,5 @@
                         return VINF_SUCCESS;
                     /** @todo more memory types! */
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_NUMBER:
@@ -1074,5 +1074,5 @@
                 case DBGCVAR_TYPE_STRING:
                 case DBGCVAR_TYPE_SYMBOL:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_UNKNOWN:
@@ -1086,8 +1086,8 @@
             {
                 case DBGCVAR_TYPE_GC_FLAT:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_FAR:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_PHYS:
@@ -1096,8 +1096,8 @@
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
-                    return VERR_PARSE_CONVERSION_FAILED;
+                    return VERR_DBGC_PARSE_CONVERSION_FAILED;
 
                 case DBGCVAR_TYPE_HC_FLAT:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_HC_PHYS:
@@ -1111,5 +1111,5 @@
                 case DBGCVAR_TYPE_STRING:
                 case DBGCVAR_TYPE_SYMBOL:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_UNKNOWN:
@@ -1128,5 +1128,5 @@
 
                 case DBGCVAR_TYPE_GC_FAR:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_GC_PHYS:
@@ -1150,5 +1150,5 @@
                 case DBGCVAR_TYPE_STRING:
                 case DBGCVAR_TYPE_SYMBOL:
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_UNKNOWN:
@@ -1181,5 +1181,5 @@
                         }
                     }
-                    return VERR_PARSE_INCORRECT_ARG_TYPE;
+                    return VERR_DBGC_PARSE_INCORRECT_ARG_TYPE;
 
                 case DBGCVAR_TYPE_STRING: