Index: trunk/src/VBox/Debugger/DBGCCmdHlp.cpp
===================================================================
--- trunk/src/VBox/Debugger/DBGCCmdHlp.cpp	(revision 41573)
+++ trunk/src/VBox/Debugger/DBGCCmdHlp.cpp	(revision 44399)
@@ -316,5 +316,5 @@
  * @interface_method_impl{DBGCCMDHLP,pfnMemRead}
  */
-static DECLCALLBACK(int) dbgcHlpMemRead(PDBGCCMDHLP pCmdHlp, PVM pVM, void *pvBuffer, size_t cbRead, PCDBGCVAR pVarPointer, size_t *pcbRead)
+static DECLCALLBACK(int) dbgcHlpMemRead(PDBGCCMDHLP pCmdHlp, void *pvBuffer, size_t cbRead, PCDBGCVAR pVarPointer, size_t *pcbRead)
 {
     PDBGC       pDbgc = DBGC_CMDHLP2DBGC(pCmdHlp);
@@ -341,6 +341,6 @@
         case DBGCVAR_TYPE_GC_FAR:
             /* Use DBGFR3AddrFromSelOff for the conversion. */
-            Assert(pDbgc->pVM);
-            rc = DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, &Address, Var.u.GCFar.sel, Var.u.GCFar.off);
+            Assert(pDbgc->pUVM);
+            rc = DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, &Address, Var.u.GCFar.sel, Var.u.GCFar.off);
             if (RT_FAILURE(rc))
                 return rc;
@@ -350,5 +350,5 @@
             {
                 DBGFSELINFO SelInfo;
-                rc = DBGFR3SelQueryInfo(pDbgc->pVM, pDbgc->idCpu, Address.Sel,
+                rc = DBGFR3SelQueryInfo(pDbgc->pUVM, pDbgc->idCpu, Address.Sel,
                                         DBGFSELQI_FLAGS_DT_GUEST | DBGFSELQI_FLAGS_DT_ADJ_64BIT_MODE, &SelInfo);
                 if (RT_SUCCESS(rc))
@@ -419,12 +419,12 @@
         {
             case DBGCVAR_TYPE_GC_FLAT:
-                rc = DBGFR3MemRead(pDbgc->pVM, pDbgc->idCpu,
-                                   DBGFR3AddrFromFlat(pVM, &Address, Var.u.GCFlat),
+                rc = DBGFR3MemRead(pDbgc->pUVM, pDbgc->idCpu,
+                                   DBGFR3AddrFromFlat(pDbgc->pUVM, &Address, Var.u.GCFlat),
                                    pvBuffer, cb);
                 break;
 
             case DBGCVAR_TYPE_GC_PHYS:
-                rc = DBGFR3MemRead(pDbgc->pVM, pDbgc->idCpu,
-                                   DBGFR3AddrFromPhys(pVM, &Address, Var.u.GCPhys),
+                rc = DBGFR3MemRead(pDbgc->pUVM, pDbgc->idCpu,
+                                   DBGFR3AddrFromPhys(pDbgc->pUVM, &Address, Var.u.GCPhys),
                                    pvBuffer, cb);
                 break;
@@ -488,5 +488,5 @@
  * @interface_method_impl{DBGCCMDHLP,pfnMemWrite}
  */
-static DECLCALLBACK(int) dbgcHlpMemWrite(PDBGCCMDHLP pCmdHlp, PVM pVM, const void *pvBuffer, size_t cbWrite, PCDBGCVAR pVarPointer, size_t *pcbWritten)
+static DECLCALLBACK(int) dbgcHlpMemWrite(PDBGCCMDHLP pCmdHlp, const void *pvBuffer, size_t cbWrite, PCDBGCVAR pVarPointer, size_t *pcbWritten)
 {
     PDBGC       pDbgc = DBGC_CMDHLP2DBGC(pCmdHlp);
@@ -514,6 +514,6 @@
         {
             /* Use DBGFR3AddrFromSelOff for the conversion. */
-            Assert(pDbgc->pVM);
-            rc = DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, &Address, Var.u.GCFar.sel, Var.u.GCFar.off);
+            Assert(pDbgc->pUVM);
+            rc = DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, &Address, Var.u.GCFar.sel, Var.u.GCFar.off);
             if (RT_FAILURE(rc))
                 return rc;
@@ -523,5 +523,5 @@
             {
                 DBGFSELINFO SelInfo;
-                rc = DBGFR3SelQueryInfo(pDbgc->pVM, pDbgc->idCpu, Address.Sel,
+                rc = DBGFR3SelQueryInfo(pDbgc->pUVM, pDbgc->idCpu, Address.Sel,
                                         DBGFSELQI_FLAGS_DT_GUEST | DBGFSELQI_FLAGS_DT_ADJ_64BIT_MODE, &SelInfo);
                 if (RT_SUCCESS(rc))
@@ -556,6 +556,6 @@
         /* fall thru */
         case DBGCVAR_TYPE_GC_FLAT:
-            rc = DBGFR3MemWrite(pVM, pDbgc->idCpu,
-                                DBGFR3AddrFromFlat(pVM, &Address, Var.u.GCFlat),
+            rc = DBGFR3MemWrite(pDbgc->pUVM, pDbgc->idCpu,
+                                DBGFR3AddrFromFlat(pDbgc->pUVM, &Address, Var.u.GCFlat),
                                 pvBuffer, cbWrite);
             if (pcbWritten && RT_SUCCESS(rc))
@@ -564,6 +564,6 @@
 
         case DBGCVAR_TYPE_GC_PHYS:
-            rc = DBGFR3MemWrite(pVM, pDbgc->idCpu,
-                                DBGFR3AddrFromPhys(pVM, &Address, Var.u.GCPhys),
+            rc = DBGFR3MemWrite(pDbgc->pUVM, pDbgc->idCpu,
+                                DBGFR3AddrFromPhys(pDbgc->pUVM, &Address, Var.u.GCPhys),
                                 pvBuffer, cbWrite);
             if (pcbWritten && RT_SUCCESS(rc))
@@ -734,16 +734,16 @@
     {
         case DBGCVAR_TYPE_GC_FLAT:
-            DBGFR3AddrFromFlat(pDbgc->pVM, pAddress, pVar->u.GCFlat);
+            DBGFR3AddrFromFlat(pDbgc->pUVM, pAddress, pVar->u.GCFlat);
             return VINF_SUCCESS;
 
         case DBGCVAR_TYPE_NUMBER:
-            DBGFR3AddrFromFlat(pDbgc->pVM, pAddress, (RTGCUINTPTR)pVar->u.u64Number);
+            DBGFR3AddrFromFlat(pDbgc->pUVM, pAddress, (RTGCUINTPTR)pVar->u.u64Number);
             return VINF_SUCCESS;
 
         case DBGCVAR_TYPE_GC_FAR:
-            return DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, pAddress, pVar->u.GCFar.sel, pVar->u.GCFar.off);
+            return DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, pAddress, pVar->u.GCFar.sel, pVar->u.GCFar.off);
 
         case DBGCVAR_TYPE_GC_PHYS:
-            DBGFR3AddrFromPhys(pDbgc->pVM, pAddress, pVar->u.GCPhys);
+            DBGFR3AddrFromPhys(pDbgc->pUVM, pAddress, pVar->u.GCPhys);
             return VINF_SUCCESS;
 
@@ -923,5 +923,5 @@
     int             rc;
 
-    Assert(pDbgc->pVM);
+    Assert(pDbgc->pUVM);
 
     *pResult = InVar;
@@ -939,6 +939,6 @@
                 case DBGCVAR_TYPE_GC_PHYS:
                     pResult->enmType = DBGCVAR_TYPE_GC_PHYS;
-                    rc = DBGFR3AddrToPhys(pDbgc->pVM, pDbgc->idCpu,
-                                          DBGFR3AddrFromFlat(pDbgc->pVM, &Address, pArg->u.GCFlat),
+                    rc = DBGFR3AddrToPhys(pDbgc->pUVM, pDbgc->idCpu,
+                                          DBGFR3AddrFromFlat(pDbgc->pUVM, &Address, pArg->u.GCFlat),
                                           &pResult->u.GCPhys);
                     if (RT_SUCCESS(rc))
@@ -948,6 +948,6 @@
                 case DBGCVAR_TYPE_HC_FLAT:
                     pResult->enmType = DBGCVAR_TYPE_HC_FLAT;
-                    rc = DBGFR3AddrToVolatileR3Ptr(pDbgc->pVM, pDbgc->idCpu,
-                                                   DBGFR3AddrFromFlat(pDbgc->pVM, &Address, pArg->u.GCFlat),
+                    rc = DBGFR3AddrToVolatileR3Ptr(pDbgc->pUVM, pDbgc->idCpu,
+                                                   DBGFR3AddrFromFlat(pDbgc->pUVM, &Address, pArg->u.GCFlat),
                                                    false /*fReadOnly */,
                                                    &pResult->u.pvHCFlat);
@@ -958,6 +958,6 @@
                 case DBGCVAR_TYPE_HC_PHYS:
                     pResult->enmType = DBGCVAR_TYPE_HC_PHYS;
-                    rc = DBGFR3AddrToHostPhys(pDbgc->pVM, pDbgc->idCpu,
-                                              DBGFR3AddrFromFlat(pDbgc->pVM, &Address, pArg->u.GCFlat),
+                    rc = DBGFR3AddrToHostPhys(pDbgc->pUVM, pDbgc->idCpu,
+                                              DBGFR3AddrFromFlat(pDbgc->pUVM, &Address, pArg->u.GCFlat),
                                               &pResult->u.GCPhys);
                     if (RT_SUCCESS(rc))
@@ -984,5 +984,5 @@
             {
                 case DBGCVAR_TYPE_GC_FLAT:
-                    rc = DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
+                    rc = DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
                     if (RT_SUCCESS(rc))
                     {
@@ -997,9 +997,9 @@
 
                 case DBGCVAR_TYPE_GC_PHYS:
-                    rc = DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
+                    rc = DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
                     if (RT_SUCCESS(rc))
                     {
                         pResult->enmType = DBGCVAR_TYPE_GC_PHYS;
-                        rc = DBGFR3AddrToPhys(pDbgc->pVM, pDbgc->idCpu, &Address, &pResult->u.GCPhys);
+                        rc = DBGFR3AddrToPhys(pDbgc->pUVM, pDbgc->idCpu, &Address, &pResult->u.GCPhys);
                         if (RT_SUCCESS(rc))
                             return VINF_SUCCESS;
@@ -1008,9 +1008,9 @@
 
                 case DBGCVAR_TYPE_HC_FLAT:
-                    rc = DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
+                    rc = DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
                     if (RT_SUCCESS(rc))
                     {
                         pResult->enmType = DBGCVAR_TYPE_HC_FLAT;
-                        rc = DBGFR3AddrToVolatileR3Ptr(pDbgc->pVM, pDbgc->idCpu, &Address,
+                        rc = DBGFR3AddrToVolatileR3Ptr(pDbgc->pUVM, pDbgc->idCpu, &Address,
                                                        false /*fReadOnly*/, &pResult->u.pvHCFlat);
                         if (RT_SUCCESS(rc))
@@ -1020,9 +1020,9 @@
 
                 case DBGCVAR_TYPE_HC_PHYS:
-                    rc = DBGFR3AddrFromSelOff(pDbgc->pVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
+                    rc = DBGFR3AddrFromSelOff(pDbgc->pUVM, pDbgc->idCpu, &Address, pArg->u.GCFar.sel, pArg->u.GCFar.off);
                     if (RT_SUCCESS(rc))
                     {
                         pResult->enmType = DBGCVAR_TYPE_HC_PHYS;
-                        rc = DBGFR3AddrToHostPhys(pDbgc->pVM, pDbgc->idCpu, &Address, &pResult->u.GCPhys);
+                        rc = DBGFR3AddrToHostPhys(pDbgc->pUVM, pDbgc->idCpu, &Address, &pResult->u.GCPhys);
                         if (RT_SUCCESS(rc))
                             return VINF_SUCCESS;
@@ -1060,6 +1060,6 @@
                 case DBGCVAR_TYPE_HC_FLAT:
                     pResult->enmType = DBGCVAR_TYPE_HC_FLAT;
-                    rc = DBGFR3AddrToVolatileR3Ptr(pDbgc->pVM, pDbgc->idCpu,
-                                                   DBGFR3AddrFromPhys(pDbgc->pVM, &Address, pArg->u.GCPhys),
+                    rc = DBGFR3AddrToVolatileR3Ptr(pDbgc->pUVM, pDbgc->idCpu,
+                                                   DBGFR3AddrFromPhys(pDbgc->pUVM, &Address, pArg->u.GCPhys),
                                                    false /*fReadOnly */,
                                                    &pResult->u.pvHCFlat);
@@ -1070,6 +1070,6 @@
                 case DBGCVAR_TYPE_HC_PHYS:
                     pResult->enmType = DBGCVAR_TYPE_HC_PHYS;
-                    rc = DBGFR3AddrToHostPhys(pDbgc->pVM, pDbgc->idCpu,
-                                              DBGFR3AddrFromPhys(pDbgc->pVM, &Address, pArg->u.GCPhys),
+                    rc = DBGFR3AddrToHostPhys(pDbgc->pUVM, pDbgc->idCpu,
+                                              DBGFR3AddrFromPhys(pDbgc->pUVM, &Address, pArg->u.GCPhys),
                                               &pResult->u.HCPhys);
                     if (RT_SUCCESS(rc))
@@ -1103,5 +1103,5 @@
                 case DBGCVAR_TYPE_GC_PHYS:
                     pResult->enmType = DBGCVAR_TYPE_GC_PHYS;
-                    rc = PGMR3DbgR3Ptr2GCPhys(pDbgc->pVM, pArg->u.pvHCFlat, &pResult->u.GCPhys);
+                    rc = PGMR3DbgR3Ptr2GCPhys(pDbgc->pUVM, pArg->u.pvHCFlat, &pResult->u.GCPhys);
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
@@ -1114,5 +1114,5 @@
                 case DBGCVAR_TYPE_HC_PHYS:
                     pResult->enmType = DBGCVAR_TYPE_HC_PHYS;
-                    rc = PGMR3DbgR3Ptr2HCPhys(pDbgc->pVM, pArg->u.pvHCFlat, &pResult->u.HCPhys);
+                    rc = PGMR3DbgR3Ptr2HCPhys(pDbgc->pUVM, pArg->u.pvHCFlat, &pResult->u.HCPhys);
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
@@ -1146,5 +1146,5 @@
                 case DBGCVAR_TYPE_GC_PHYS:
                     pResult->enmType = DBGCVAR_TYPE_GC_PHYS;
-                    rc = PGMR3DbgHCPhys2GCPhys(pDbgc->pVM, pArg->u.HCPhys, &pResult->u.GCPhys);
+                    rc = PGMR3DbgHCPhys2GCPhys(pDbgc->pUVM, pArg->u.HCPhys, &pResult->u.GCPhys);
                     if (RT_SUCCESS(rc))
                         return VINF_SUCCESS;
@@ -1310,6 +1310,6 @@
     if (pDbgc->fRegCtxGuest)
     {
-        if (pDbgc->pVM)
-            enmMode = DBGFR3CpuGetMode(pDbgc->pVM, DBGCCmdHlpGetCurrentCpu(pCmdHlp));
+        if (pDbgc->pUVM)
+            enmMode = DBGFR3CpuGetMode(pDbgc->pUVM, DBGCCmdHlpGetCurrentCpu(pCmdHlp));
         if (enmMode == CPUMMODE_INVALID)
 #if HC_ARCH_BITS == 64